package model;


import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author docente
 */
public class SequenzaFile<T extends RandomAccessInterface> implements Sequenza<T> {
    private RandomAccessFile f;
//    private int tSize;
    private T maker;
    
    public SequenzaFile(T maker,File fseq) throws FileNotFoundException {
      this.maker=maker;
//      tSize=maker.getSize();
      f = new RandomAccessFile(fseq,"rw");
    }
    public SequenzaFile(T maker) throws FileNotFoundException {
      this.maker=maker;
      f = new RandomAccessFile(new File(generaNomeUnivoco()),"rw");
    }
    private String generaNomeUnivoco(){
        return "NomeUnivoco";//TODO va implementato!
    }


    @Override
    public void appendi(T dato) {
        try {
            //portiamo il cursore a fine file
            f.seek(f.length());
            dato.write(f);
        } catch (IOException ex) {
            Logger.getLogger(SequenzaFile.class.getName()).log(Level.SEVERE, null, ex);
            throw new RuntimeException("Errore di accesso al file");
        }
    }

    @Override
    public void elimina(int i) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public T getElemento(int i) {
        try {
            //porta il cursore alla posizione dell'elemento i
            int pos=i*maker.getSize();
            f.seek(pos);
//            T.statico();
            T dato=(T) maker.factory();
            dato.read(f);
            return dato;
        } catch (IOException ex) {
            Logger.getLogger(SequenzaFile.class.getName()).log(Level.SEVERE, null, ex);
            throw new RuntimeException("Errore di accesso al file");
        }
    }

    @Override
    public int getLunghezza() {
        try {
            //divido la lunghezza del file per la lunghezza di un oggetto
            if (f.length()==0){
                return 0;
            }
            else {
                int n=(int) ((f.length())/maker.getSize());
                return n;
            }
        } catch (IOException ex) {
            Logger.getLogger(SequenzaFile.class.getName()).log(Level.SEVERE, null, ex);
            throw new RuntimeException("Errore di accesso al file");
        }
    }

    @Override
    public void inserisci(T dato, int i) {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public boolean isEmpty() {
        try {
            return f.length()==0;
        } catch (IOException ex) {
            Logger.getLogger(SequenzaFile.class.getName()).log(Level.SEVERE, null, ex);
            return true;
        }
    }
    
}
